not(X):-X,!,no.
not(X).

 conceito(Cidade).
conceito(Ligação).
	atributos(Cidade, [descrição:string, distrito:string, nome:string, população:string]).
	atributos(Ligação, [distância:string]).
relacao(éOrigemDe).
relacao(iof).
relacao(isa).
relacao(synonym).
relacao(temDestino).
relacao(temOrigem).
relacao(éDestinoDe).
relacao(pof).
individuo(lig-ptl-brg).
individuo(fml).
individuo(vct).
individuo(lig-brg-fml).
individuo(ptl).
individuo(lig-vct-prt).
individuo(bcl).
individuo(gmr).
individuo(lig-ptl-bcl).
individuo(lig-bcl-vct).
individuo(prt).
individuo(brg).
individuo(lig-brg-bcl).
individuo(lig-brg-gmr).
individuo(lig-gmr-fml).
individuo(lig-gmr-prt).
individuo(lig-fml-prt).
individuo(lig-fml-bcl).
iof(bcl, Cidade).
iof(brg, Cidade).
iof(fml, Cidade).
iof(gmr, Cidade).
iof(lig-bcl-vct, Ligação).
iof(lig-brg-bcl, Ligação).
iof(lig-brg-fml, Ligação).
iof(lig-brg-gmr, Ligação).
iof(lig-fml-bcl, Ligação).
iof(lig-fml-prt, Ligação).
iof(lig-gmr-fml, Ligação).
iof(lig-gmr-prt, Ligação).
iof(lig-ptl-bcl, Ligação).
iof(lig-ptl-brg, Ligação).
iof(lig-vct-prt, Ligação).
iof(prt, Cidade).
iof(ptl, Cidade).
iof(vct, Cidade).
temOrigem(lig-bcl-vct, bcl).
temOrigem(bcl, lig-bcl-vct).
temOrigem(lig-brg-bcl, brg).
temOrigem(brg, lig-brg-bcl).
temOrigem(lig-brg-fml, brg).
temOrigem(brg, lig-brg-fml).
temOrigem(lig-brg-gmr, brg).
temOrigem(brg, lig-brg-gmr).
temOrigem(lig-fml-bcl, fml).
temOrigem(fml, lig-fml-bcl).
temOrigem(lig-fml-prt, fml).
temOrigem(fml, lig-fml-prt).
temOrigem(lig-gmr-fml, gmr).
temOrigem(gmr, lig-gmr-fml).
temOrigem(lig-gmr-prt, gmr).
temOrigem(gmr, lig-gmr-prt).
temOrigem(lig-ptl-bcl, ptl).
temOrigem(ptl, lig-ptl-bcl).
temOrigem(lig-ptl-brg, ptl).
temOrigem(ptl, lig-ptl-brg).
temOrigem(lig-vct-prt, vct).
temOrigem(vct, lig-vct-prt).
temDestino(lig-bcl-vct, vct).
temDestino(vct, lig-bcl-vct).
temDestino(lig-brg-bcl, bcl).
temDestino(bcl, lig-brg-bcl).
temDestino(lig-brg-fml, fml).
temDestino(fml, lig-brg-fml).
temDestino(lig-brg-gmr, bcl).
temDestino(bcl, lig-brg-gmr).
temDestino(lig-fml-bcl, bcl).
temDestino(bcl, lig-fml-bcl).
temDestino(lig-fml-prt, prt).
temDestino(prt, lig-fml-prt).
temDestino(lig-gmr-fml, fml).
temDestino(fml, lig-gmr-fml).
temDestino(lig-gmr-prt, prt).
temDestino(prt, lig-gmr-prt).
temDestino(lig-ptl-bcl, bcl).
temDestino(bcl, lig-ptl-bcl).
temDestino(lig-ptl-brg, brg).
temDestino(brg, lig-ptl-brg).
temDestino(lig-vct-prt, prt).
temDestino(prt, lig-vct-prt).
propriedades( lig-ptl-brg , ["31"]).
propriedades( fml , ["Princesa do Ave", "Braga", "Famalicão", "90000"]).
propriedades( vct , ["Cidade dos pescadores", "Viana do Castelo", "Viana do Castelo", "60000"]).
propriedades( lig-brg-fml , ["17"]).
propriedades( lig-vct-prt , ["61"]).
propriedades( ptl , ["Vila mais antiga de Portugal", "Viana do Castelo", "Ponte de Lima", "70000"]).
propriedades( bcl , ["Cidade do Galo", "Braga", "Barcelos", "60000"]).
propriedades( gmr , ["Cidade berço", "Braga", "Guimarães", "80000"]).
propriedades( lig-ptl-bcl , ["19"]).
propriedades( lig-bcl-vct , ["22"]).
propriedades( prt , ["Cidade invicta", "Porto", "Porto", "100000"]).
propriedades( lig-brg-bcl , ["20"]).
propriedades( brg , ["Cidade dos Arcebispos", "Braga", "Braga", "140000"]).
propriedades( lig-gmr-fml , ["22"]).
propriedades( lig-brg-gmr , ["18"]).
propriedades( lig-gmr-prt , ["38"]).
propriedades( lig-fml-prt , ["30"]).
propriedades( lig-fml-bcl , ["25"]).
classeDe(Coisa, Classe):- iof(Coisa, Classe).
classeDe(Coisa, Classe):- isa(Coisa, Classe).

validaISA:- isa(X,Y), conceitos(X,Y), fail.
validaISA:- write('Fim da Validação!'), nl.

conceitos(X,Y):- conceito(X), conceito(Y), !.
conceitos(X,Y):- write('Um dos termos '), write(X), write(' ou '), write(Y), write('Não é um CONCEITO.'), nl.

validaIOF :- iof(X,Y), instconc(X,Y), fail.
validaIOF :- write('Fim da Validação!'), nl.

instconc(X,Y) :- instancia(X), conceito(Y), !.
instconc(X,Y) :- write('Um dos termos '), write(X), write(' ou '), write(Y), write('Não é uma INSTANCIA ou um CONCEITO.'), nl.

