package OntoDLPlus;

import OntoDLPlus.*;
import java.util.HashSet;
import java.util.HashMap;
import java.util.List;
import java.lang.StringBuilder;

public class SemError {
    private String detail;

    public SemError(final String msg) {
        this.detail = msg;
    }

    public SemError clone() {
        return new SemError(this.detail);
    }

    public boolean equals(final Object o) {
        if (o == this)
            return true;
        if (o == null || o.getClass() != this.getClass())
            return false;
        SemError s = (SemError) o;
        if(!this.detail.equals(s.getDetail())) return false;
        return true;
    }

    public String getDetail(){return this.detail;}

    public String toString() {
        return this.detail+"\n";
    }
}
