// Generated from /home/beggar/Universidade/Tese/OntoDLsrc/OntoDLPlus.g4 by ANTLR 4.8

        import java.util.*;
        import java.io.BufferedWriter;
        import java.nio.file.*;
        import java.nio.file.StandardOpenOption;
        import java.nio.file.attribute.FileAttribute;
        import java.nio.file.attribute.PosixFilePermission;
        import java.nio.file.attribute.PosixFilePermissions;
        import java.nio.charset.Charset;
        import java.nio.charset.StandardCharsets;
        import OntoDLPlus.*;

import org.antlr.v4.runtime.tree.ParseTreeVisitor;

/**
 * This interface defines a complete generic visitor for a parse tree produced
 * by {@link OntoDLPlusParser}.
 *
 * @param <T> The return type of the visit operation. Use {@link Void} for
 * operations with no return type.
 */
public interface OntoDLPlusVisitor<T> extends ParseTreeVisitor<T> {
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#ontology}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitOntology(OntoDLPlusParser.OntologyContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#atribs}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitAtribs(OntoDLPlusParser.AtribsContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#concepts}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitConcepts(OntoDLPlusParser.ConceptsContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#concept}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitConcept(OntoDLPlusParser.ConceptContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#attributes}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitAttributes(OntoDLPlusParser.AttributesContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#simpAtrib}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitSimpAtrib(OntoDLPlusParser.SimpAtribContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#attribute}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitAttribute(OntoDLPlusParser.AttributeContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#tipo}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitTipo(OntoDLPlusParser.TipoContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#inviduals}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitInviduals(OntoDLPlusParser.InvidualsContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#relations}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRelations(OntoDLPlusParser.RelationsContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#relInf}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRelInf(OntoDLPlusParser.RelInfContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#properties}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitProperties(OntoDLPlusParser.PropertiesContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#property}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitProperty(OntoDLPlusParser.PropertyContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#triples}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitTriples(OntoDLPlusParser.TriplesContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#triple}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitTriple(OntoDLPlusParser.TripleContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#relationship}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRelationship(OntoDLPlusParser.RelationshipContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#relAtrib}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRelAtrib(OntoDLPlusParser.RelAtribContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#multiRel}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitMultiRel(OntoDLPlusParser.MultiRelContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#atribInsts}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitAtribInsts(OntoDLPlusParser.AtribInstsContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#atribInst}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitAtribInst(OntoDLPlusParser.AtribInstContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#restrictions}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRestrictions(OntoDLPlusParser.RestrictionsContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#restriction}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRestriction(OntoDLPlusParser.RestrictionContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#guards}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitGuards(OntoDLPlusParser.GuardsContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#disjunctions}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitDisjunctions(OntoDLPlusParser.DisjunctionsContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#conjunctions}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitConjunctions(OntoDLPlusParser.ConjunctionsContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#conjunction}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitConjunction(OntoDLPlusParser.ConjunctionContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#guard}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitGuard(OntoDLPlusParser.GuardContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#domain}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitDomain(OntoDLPlusParser.DomainContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#counterdomain}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitCounterdomain(OntoDLPlusParser.CounterdomainContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#conceptsKey}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitConceptsKey(OntoDLPlusParser.ConceptsKeyContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#objectProps}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitObjectProps(OntoDLPlusParser.ObjectPropsContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#dataProperties}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitDataProperties(OntoDLPlusParser.DataPropertiesContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#not}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitNot(OntoDLPlusParser.NotContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#isa}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitIsa(OntoDLPlusParser.IsaContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#iof}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitIof(OntoDLPlusParser.IofContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#syn}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitSyn(OntoDLPlusParser.SynContext ctx);
	/**
	 * Visit a parse tree produced by {@link OntoDLPlusParser#pof}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitPof(OntoDLPlusParser.PofContext ctx);
}